#include "../Framework2/OpenGL/OpenGLApp.h"
#include "../Framework2/Util/OpenGLModel.h"

struct Edge {
	Edge(){
		count = 0;
	}
	Edge(const unsigned int ii0, const unsigned int ii1, const vec3 &normal){
		i0 = min(ii0, ii1);
		i1 = max(ii0, ii1);
		normal0 = normal;
		count = 0;
	}

	unsigned int i0, i1;
	vec3 normal0, normal1;
	unsigned int count;
};

bool operator != (const Edge &e0, const Edge &e1){
	return (e0.i0 != e1.i0 || e0.i1 != e1.i1);
}

bool operator < (const Edge &e0, const Edge &e1){
	if (e0.i0 < e1.i0) return true;
	if (e0.i0 > e1.i0) return false;
	return (e0.i1 < e1.i1);
}

struct Vertex {
	vec3 vertex;
	vec3 normal0;
	vec3 normal1;
};

class MainApp : public OpenGLApp {
public:
	void resetCamera();

	void initMenu();
	bool init();
	bool exit();

	bool load();
	bool unload();

	bool drawFrame();
protected:
	OpenGLModel *model, *edgeModel;

	ShaderID outline, shading;
	TextureID celShade;

	int edgeThreshold, lineWidth;
	bool drawOutline, drawEdge;
};
